React + Turbolinks integration break when submitting forms
Priority: Normal   

Assignee: Avi Sharvit   

Category: JavaScript stack   

Target version:    

Difficulty:  Fixed in Releases: 1.18.0

Triaged: No Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/5462,

https://github.com/theforeman/foreman/p

ull/5791

  

Description

In the react-engine, we listen to turbolinks to clean all the react components when moving between pages:

https://github.com/theforeman/foreman/blob/develop/webpack/assets/javascripts/react_app/common/MountingService.js#L15

When performing form-submit (edit host, save), the event isn't triggering and we got the same components mounted twice into the

dom.

For example:

go to hosts > click edit > click submit > click the breadcrumb sibling selector and pick another host.

its lands in another_host/edit because it uses the breadcrumb-bar from the previews mounting.

Related issues:

Related to Foreman - Bug #24320: Unable to provision on Vmware, no storage da... Closed

Copied to Foreman - Bug #24345: Breadcrumbs isn't refreshed properly after vi... Closed

Associated revisions

Revision b976723b - 07/09/2018 10:16 AM - Avi Sharvit

Fixes #23290 - Unmount components before dom-update

provide core `tfm.reactMounter.unmountComponents` function

unmount components before saving host and manually update the dom with

jquery

History

#1 - 04/17/2018 09:02 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/5462 added

#2 - 07/03/2018 10:19 AM - Avi Sharvit

- translation missing: en.field_release set to 330

- Triaged set to No

#3 - 07/09/2018 11:01 AM - Avi Sharvit

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset b976723b58ad34ef9af77816541b42efc76c1b2a.

#4 - 07/09/2018 11:43 AM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman/pull/5791 added
#5 - 07/09/2018 01:23 PM - Ondřej Pražák

- Fixed in Releases 1.18.0 added

#6 - 07/20/2018 08:07 AM - Marek Hulán

- Related to Bug #24320: Unable to provision on Vmware, no storage data submitted added

#7 - 07/20/2018 10:48 AM - Marek Hulán

- Status changed from Closed to New

- Target version deleted (1.18.0)

- Fixed in Releases deleted (1.18.0)

Reopening, this does not seem to be fixed. #24320 in fact plans to revert the fix as it didn't seem to help, see 

https://github.com/theforeman/foreman/pull/5864#issuecomment-406555558 for more info

#8 - 07/22/2018 07:49 AM - Tomer Brisker

- Status changed from New to Closed

- Target version set to 1.18.0

- Fixed in Releases 1.18.0 added

Closing again. This has been shipped already in 1.18.0. Please open a new issue if needed for tracking regression caused by reverting this change.

#9 - 07/23/2018 07:18 AM - Marek Hulán

- Status changed from Closed to New

- Target version deleted (1.18.0)

- Fixed in Releases deleted (1.18.0)

Tomer, this is not fixed. The linked PR didn't solve the issue and it can still be reproduced on 1.18.

#10 - 07/23/2018 08:26 AM - Marek Hulán

- Status changed from New to Closed

- Fixed in Releases 1.18.0 added

After a discussion on IRC, turns out it fixed one instance of the problem, so keeping at 1.18 as closed. Revert is already in develop and another fix

should be applies, so cloning the issue for tracking.

#11 - 07/23/2018 08:32 AM - Marek Hulán

- Copied to Bug #24345: Breadcrumbs isn't refreshed properly after visiting host edit form added
